/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


orderingControllers.controller('CreateOrderCtrl', function ($scope,Configuration,CreateOrderServices,InformationModalService,$state) {
    Configuration.initialize();
    $scope.configuration = Configuration.getConfiguration();
    $scope.rentalItems = [];
    $scope.customerSites = [];
    
    $scope.order = {};
    $scope.order.patient = {};
    $scope.order.selectedQuantity=1;
    $scope.order.combinedCustomerBean = $scope.configuration.combinedCustomerBean;
    
    
    
    
    
    
    $scope.order.contact = {};
    
    if( $scope.configuration.selectedContact !== null && $scope.configuration.selectedContact !== "" ){
        $scope.order.contact.id = $scope.configuration.selectedContact.id;
        $scope.order.contact.name = $scope.configuration.selectedContact.name;
    }
    else
    {
        $scope.order.contact.id = $scope.configuration.operatorId;
        $scope.order.contact.name = $scope.configuration.operatorName;
    }
    
    
    console.log("Customer");
    console.log( $scope.configuration.combinedCustomerBean );
    
    var loadCombos = function(){
        CreateOrderServices.getRentalItems().then(function(rentalItems){
           
           
           var filteredRentalItems = rentalItems.filter(function(each){
              
               if( each.equipmentCategory === 'PUMP' )
                   return false;
               else
                   return true;
           });
                   
                   
           $scope.rentalItems = filteredRentalItems;        
       
        });
        
        
        console.log("$scope.configuration.selectedContact");
        console.log($scope.configuration.selectedContact);
        
        CreateOrderServices.getCustomerSites($scope.configuration.combinedCustomerBean).then(function(customerSites){
            
            
           
           if( $scope.configuration.selectedContact.custsiteIds.length > 0 ){
                var filteredCustomerSites = customerSites.filter(function(site){
                     var matches = false;
                     angular.forEach($scope.configuration.selectedContact.custsiteIds,function(each){
                         
                         if( each === site.id )
                             matches = true;
                     });
                     return matches;
                });
                $scope.customerSites = filteredCustomerSites;
           }else
                $scope.customerSites = customerSites;
         
         
            // now set the selected ward equal to the first item in list.
            $scope.order.selectedCustomerSite = $scope.customerSites[0];
        });
        
        
    };
    
    
    var validateOrder = function(){
        var errorMessage = "";
        if( typeof $scope.patient.firstName === 'undefined' || !$scope.patient.firstName ){
            errorMessage = errorMessage + "First Name\n";
        };
         if( typeof $scope.patient.lastName === 'undefined' || !$scope.patient.lastName ){
            errorMessage = errorMessage + "Last Name\n";
        };
        
        
        return errorMessage;
    };
    
    $scope.sendOrder = function(){
        console.log("Creating Order");
        
        console.log("$scope.order");
        console.log($scope.order);
        
        
        CreateOrderServices.createNewOrder($scope.order).then(function(result){
            InformationModalService.showModal("Success","Order Successfully Created");
            $state.go("base.home");
        },
        function(error){
            InformationModalService.showModal("Failure","Order Failed to  create");
            
        });
        
    };
    
    loadCombos();
    
});