/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


orderingServices.factory('TransferPatientServices', function ($q, ContractResource) {
    
   var transferPatientGridOptions = function () {
         var gridOptions = [
            {field: 'documentNumber', name: 'CHC', type: 'number' ,cellClass:"noborder",headerCellClass:"noborder"},
            {field: 'detailLines[0].description', name: 'Product',cellClass:"noborder",headerCellClass:"noborder",width:'20%'},
            {field: 'patient.name', name: 'Patient',cellClass:"noborder",headerCellClass:"noborder",width:'20%'},
            {field: 'patient.id', name: 'Patient ID',cellClass:"noborder",headerCellClass:"noborder"},
            {field: 'pumpNo', name: 'Pump #',cellClass:"noborder",headerCellClass:"noborder"},
            {field: 'site.name', name: 'Ward Name',cellClass:"noborder",headerCellClass:"noborder"},
            {field: 'detailLines[0].qty', name: 'Quantity',cellClass:"noborder",headerCellClass:"noborder"},
            {field: 'documentNumber', name: '', cellTemplate: '<div class="ui-grid-cell-contents"><button type="button" class="btn btn-danger" ng-click=\'grid.appScope.transferPatient(row.entity)\'>Transfer</button></div>',cellClass:"noborder",headerCellClass:"noborder"}
           ];

        
        return gridOptions;
   };
   
   var transferPatientToNewWard = function( contract , newWard ){
     
       var transferPatientDTO = {};
       transferPatientDTO.newSiteId = newWard.id;
       transferPatientDTO.documentBean = contract;
       
       return ContractResource.transferContractToNewSite( transferPatientDTO );
       
   };
   
   return{
       transferPatientGridOptions: transferPatientGridOptions,
       transferPatientToNewWard: transferPatientToNewWard
   };
   
});

