/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


orderingControllers.controller('LoginCtrl', function ($scope, $log, $timeout, Configuration, LoginService, $state) {
    // todo
    $scope.showNav = false;
    $log.info("Running LoginCtrl");
    Configuration.initialize();
    $scope.login = false;
    var configuration = Configuration.getConfiguration();

    $scope.baseURL = Configuration.getConfiguration().baseURL;
    $scope.isCollapsed = true;
    
    $scope.username = "";
    $scope.password = "";
    $scope.showLoginFailed = false;
    $scope.loggingIn = "";

    $scope.login = function () {
        
        console.log("running Loing");
         $scope.loggingIn = "glyphicon glyphicon-refresh spinning";
        console.log($scope.username);
        console.log($scope.password);
        
        //Do configuration later
       localStorage.jemserInternal = 1;
        
       LoginService.getToken($scope.username, $scope.password).then(function (r) {
            $log.info(r);
            if (r.jwtToken !== undefined) {
                sessionStorage.email = $scope.username;
                sessionStorage.password = $scope.password;
                sessionStorage.personId = r.operatorId;
                sessionStorage.primaryCompanyId = r.primaryCompanyId;
                
                sessionStorage.accountType = r.combinedCustomerBean.accountType;
                
                
                configuration.jsonwebtoken = r.jwtToken;
                configuration.username = $scope.username;
                configuration.password = $scope.password;
                
               
                configuration.combinedCustomerBean = r.combinedCustomerBean;
                configuration.operatorName = r.operatorName;
                configuration.operatorId = r.operatorId;
                
                // we want to set selectedContact in all cases for consistent use of filtering 
                // wards
                if( sessionStorage.accountType !=='S'){
                    // set the selectedOperator value
                    angular.forEach(configuration.combinedCustomerBean.contacts,function(each){
                       if( each.id === configuration.operatorId )
                           configuration.selectedContact = each;
                    });
                }
                
                Configuration.saveLoginConfiguration();
                
                $state.go("base.home");

            } else {
                Configuration.clearLoginConfiguration();
                $scope.showLoginFailed = true;
                $timeout(function () {
                    $scope.showLoginFailed = false;
                    $scope.loggingIn = "";
                }, 2000);
            }
            ;
            
        });
    };
});

orderingControllers.directive('myEnter', function () {
    return function (scope, element, attrs) {
        element.bind("keydown keypress", function (event) {
            if (event.which === 13) {
                scope.$apply(function () {
                    scope.$eval(attrs.myEnter);
                });

                event.preventDefault();
            }
        });
    };

});

